// SonsMenu.cpp: implementation of the SonsMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "SonsMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SonsMenu::SonsMenu()
{

	this->image = new RULES_Texture();
	image->loadBMP("./ressources/textures/fond_menu.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_REPEAT,GL_REPEAT,0,false,192,192,192,0,1);

	retour = new Bouton();
	RULES_Texture * retour1 = new RULES_Texture();
	RULES_Texture * retour2 = new RULES_Texture();
	retour1->loadBMP("./ressources/textures/ihm/retour1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	retour2->loadBMP("./ressources/textures/ihm/retour2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	retour->setImageNormal(retour2);
	retour->setImagePassed(retour1);
	retour->setHeight(32);
	retour->setWidth(64);
	retour->setPosition(100,650);

	useEffect = new Bouton();
	RULES_Texture * check1= new RULES_Texture();
	RULES_Texture * check2= new RULES_Texture();
	RULES_Texture * check3= new RULES_Texture();
	RULES_Texture * check4= new RULES_Texture();
	RULES_Texture * check5= new RULES_Texture();
	RULES_Texture * check6= new RULES_Texture();
	check1->loadBMP("./ressources/textures/ihm/check.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	check2->loadBMP("./ressources/textures/ihm/check.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	check3->loadBMP("./ressources/textures/ihm/check.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	check4->loadBMP("./ressources/textures/ihm/check.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	check5->loadBMP("./ressources/textures/ihm/check.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	check6->loadBMP("./ressources/textures/ihm/check.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);

	useEffect->setImageNormal(check1);
	useEffect->setImagePassed(check2);
	useEffect->setHeight(16);
	useEffect->setWidth(16);
	useEffect->setPosition(100,300);

	RULES_Texture * droite1 = new RULES_Texture();
	RULES_Texture * droite2 = new RULES_Texture();
	RULES_Texture * droite3 = new RULES_Texture();
	RULES_Texture * droite4 = new RULES_Texture();
	droite1->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	droite2->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	droite3->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	droite4->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);

	RULES_Texture * gauche1 = new RULES_Texture();
	RULES_Texture * gauche2 = new RULES_Texture();
	RULES_Texture * gauche3 = new RULES_Texture();
	RULES_Texture * gauche4 = new RULES_Texture();
	gauche1->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	gauche2->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	gauche3->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	gauche4->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	
	effectUp = new Bouton();
	effectUp->setImageNormal(droite1);
	effectUp->setImagePassed(droite2);
	effectUp->setHeight(16);
	effectUp->setWidth(16);
	effectUp->setPosition(500,300);

	effectDown = new Bouton();
	effectDown->setImageNormal(gauche1);
	effectDown->setImagePassed(gauche2);
	effectDown->setHeight(16);
	effectDown->setWidth(16);
	effectDown->setPosition(400,300);

	useMusic = new Bouton();
	useMusic->setImageNormal(check3);
	useMusic->setImagePassed(check4);
	useMusic->setHeight(16);
	useMusic->setWidth(16);
	useMusic->setPosition(100,400);

	musicUp = new Bouton();
	musicUp->setImageNormal(droite3);
	musicUp->setImagePassed(droite4);
	musicUp->setHeight(16);
	musicUp->setWidth(16);
	musicUp->setPosition(500,400);

	musicDown = new Bouton();
	musicDown->setImageNormal(gauche3);
	musicDown->setImagePassed(gauche4);
	musicDown->setHeight(16);
	musicDown->setWidth(16);
	musicDown->setPosition(400,400);

	randomPlayList = new Bouton();
	randomPlayList->setImageNormal(check5);
	randomPlayList->setImagePassed(check6);
	randomPlayList->setHeight(16);
	randomPlayList->setWidth(16);
	randomPlayList->setPosition(100,550);
}

SonsMenu::~SonsMenu()
{
	if (retour != NULL)
	{
		delete retour ;
		retour = NULL;
	}
	if (useEffect != NULL)
	{
		delete useEffect ;
		useEffect = NULL;
	}
	if (effectUp != NULL)
	{
		delete effectUp ;
		effectUp = NULL;
	}
	if (effectDown != NULL)
	{
		delete effectDown ;
		effectDown = NULL;
	}
	if (useMusic != NULL)
	{
		delete useMusic ;
		useMusic = NULL;
	}
	if (musicUp != NULL)
	{
		delete musicUp ;
		musicUp = NULL;
	}
	if (musicDown != NULL)
	{
		delete musicDown ;
		musicDown = NULL;
	}
	if (randomPlayList != NULL)
	{
		delete randomPlayList ;
		randomPlayList = NULL;
	}
	if (image != NULL)
	{
		delete this->image ;
		image = NULL;
	}

}

void SonsMenu::draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	gluLookAt(0,100,100,0,0,0,0,1,0);

	glEnable(GL_TEXTURE_2D);
	// on desactive le depth test
	glDisable(GL_DEPTH_TEST);
	// on passe en mode projection
	glMatrixMode(GL_PROJECTION);
		
				// on sauvegarde la matrice de projection
	glPushMatrix();
	
		// on nettoie la matrice de projection
		glLoadIdentity();
		
		// on passe en mode ortho de la taille de l'ecran
		glOrtho(0,1024,0,768,-1,1);	
		
		// on passe en mode modelview
		glMatrixMode(GL_MODELVIEW);
		
		// on sauvegarde la matrice de modelview
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, this->image->getId());
			glBegin(GL_QUADS);
				glTexCoord2f(0,0);
				glVertex3f(0,0,0);
				glTexCoord2f(1,0);
				glVertex3f(1024,0,0);
				glTexCoord2f(1,1);
				glVertex3f(1024,768,0);
				glTexCoord2f(0,1);
				glVertex3f(0,768,0);
			glEnd();

			glMatrixMode(GL_PROJECTION);
		
		// et on recupere la matrice de projection sauvegard precedement
		glPopMatrix();	
		
		// on selectionne la matrice de projection modelview
		glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	// on desactive le depth test
	glEnable(GL_DEPTH_TEST);
	
	//glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER,0);
	retour->draw(mouseX,mouseY);
	effectDown->draw(mouseX,mouseY);
	effectUp->draw(mouseX,mouseY);
	musicDown->draw(mouseX,mouseY);
	musicUp->draw(mouseX,mouseY);
	useEffect->draw(mouseX,mouseY);
	useMusic->draw(mouseX,mouseY);
	if (SoundManager::getInstance()->getPlayList()->isOk())
	{
		randomPlayList->draw(mouseX,mouseY);
	}
	//glDisable(GL_ALPHA_TEST);

	Font * font = MainMenu::getInstance()->getFont();
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_SRC_ALPHA);
	// la font ettant declare en 800*600 il faut * par 0.78 pour passer en 1024*768
	if (SoundManager::getInstance()->isUsingEffect())
	{
		font->glText2d(99*0.78,300*0.78,"X");
	}
	font->glText2d(120*0.78,300*0.78,"Utiliser les effets");
	if ((SoundManager::getInstance()->musicUsingMode()==1)||(SoundManager::getInstance()->musicUsingMode()==2))
	{
		font->glText2d(99*0.78,400*0.78,"X");
	}
	int level = (SoundManager::getInstance()->getEffectSoundLevel()/255.f)*100;
	font->glText2d(420*0.78,300*0.78,"%d %c",level,'%');
	font->glText2d(120*0.78,400*0.78,"Utiliser la musique");
	level = (SoundManager::getInstance()->getMusicSoundLevel()/255.f)*100;
	font->glText2d(420*0.78,400*0.78,"%d %c",level,'%');
	if (SoundManager::getInstance()->getPlayList()->isOk())
	{
		font->glText2d(90*0.78,500*0.78,"une playlist Winamp valide a ete trouvee et va etre jouee");
		if (SoundManager::getInstance()->getPlayList()->isRandom())
		{
			font->glText2d(99*0.78,550*0.78,"X");
		}
		font->glText2d(120*0.78,550*0.78,"Playlist Winamp aleatoire");
	}
	else
	{
		font->glText2d(90*0.78,500*0.78,"Une playliste Winamp peut etre placee dans le repertoire ");
		font->glText2d(90*0.78,520*0.78,"ressource/playlist pour etre jouee pendant le jeux.");
		font->glText2d(90*0.78,540*0.78,"(attention a bien editer le fichier base_repertoire.txt)");

	}
	font->glText2d(300,150,"Gestion du son");
	glDisable(GL_BLEND);

	RULES_Vector pos;
	pos.setCoord(mouseX,768-mouseY,0);
	ParticleEngine::getInstance()->frame(&pos);
	Mouse::getInstance()->draw(&pos);

	glFlush();
	glutSwapBuffers();
}


void SonsMenu::idle(void)
{
	// on verifie le son
	SoundManager::getInstance()->checkSound();
	glutPostRedisplay();

}


void SonsMenu::mouseClicked(int boutton,int etat,int x,int y)
{
	if (etat == GLUT_DOWN)
	{
		SoundManager::getInstance()->playClic();
		if (retour->isIn(x,y))
		{
			GLUT * option = OptionMenu::getInstance();
			*(this->currentGlut) = option; 
			option->setCurrentGlut(this->currentGlut);
		}
		if (effectDown->isIn(x,y))
		{
			if (SoundManager::getInstance()->getEffectSoundLevel() > 0)
			{
				SoundManager::getInstance()->setEffectSoundLevel(SoundManager::getInstance()->getEffectSoundLevel()-10);
			}
		}
		if (effectUp->isIn(x,y))
		{
			if (SoundManager::getInstance()->getEffectSoundLevel() < 255)
			{
				SoundManager::getInstance()->setEffectSoundLevel(SoundManager::getInstance()->getEffectSoundLevel()+10);
			}
		}
		if (musicDown->isIn(x,y))
		{
			if (SoundManager::getInstance()->getMusicSoundLevel() > 0)
			{
				SoundManager::getInstance()->setMusicSoundLevel(SoundManager::getInstance()->getMusicSoundLevel()-10);
			}
		}
		if (musicUp->isIn(x,y))
		{
			if (SoundManager::getInstance()->getMusicSoundLevel() < 255)
			{
				SoundManager::getInstance()->setMusicSoundLevel(SoundManager::getInstance()->getMusicSoundLevel()+10);
			}
		}
		if (useEffect->isIn(x,y))
		{
			SoundManager::getInstance()->setUseEffect(!SoundManager::getInstance()->isUsingEffect());
		}
		if (useMusic->isIn(x,y))
		{
			if (SoundManager::getInstance()->musicUsingMode() !=0)
			{
				SoundManager::getInstance()->setUseMusic(false);
			}
			else
			{
				SoundManager::getInstance()->setUseMusic(true);
			}
		}
		if (randomPlayList->isIn(x,y))
		{
			SoundManager::getInstance()->getPlayList()->setRandom(!SoundManager::getInstance()->getPlayList()->isRandom());
		}
	}


}

void SonsMenu::mouseMoved(int x,int y)
{
	mouseX = x;
	mouseY = y;
}

void SonsMenu::mouseMovedClicked(int x,int y)
{

}


void SonsMenu::keyPressed(unsigned char key,int x,int y)
{
	
}

void SonsMenu::keyReleased(unsigned char key,int x,int y)
{
	if (key == 27)
	{
		GLUT * option = OptionMenu::getInstance();
		*(this->currentGlut) = option; 
		option->setCurrentGlut(this->currentGlut);
	}
}


void SonsMenu::reshape(int largeur,int hauteur)
{
	glViewport(0,0,(GLsizei) largeur,(GLsizei) hauteur);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,largeur/hauteur,1,10000);
	glMatrixMode(GL_MODELVIEW);

}

