// VideoMenu.cpp: implementation of the VideoMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "VideoMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

VideoMenu::VideoMenu()
{
	this->image = new RULES_Texture();
	image->loadBMP("./ressources/textures/fond_menu.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_REPEAT,GL_REPEAT,0,false,192,192,192,0,1);

	settingHasChange = false;

	loutreLow = false;
	texQuality = 0;
	glowQuality = 2;
	filtrageQuality = 3;

	retour = new Bouton();
	loutreLowCheck = new Bouton();
	texQualityUp = new Bouton();
	texQualityDown = new Bouton();
	glowQualityUp = new Bouton();
	glowQualityDown = new Bouton();
	filtrageQualityUp = new Bouton();
	filtrageQualityDown = new Bouton();

	RULES_Texture * retour1 =			new RULES_Texture();
	RULES_Texture * retour2 =			new RULES_Texture();
	RULES_Texture * loutreCheck1 =		new RULES_Texture();
	RULES_Texture * loutreCheck2 =		new RULES_Texture();
	RULES_Texture * texQualUp1 =		new RULES_Texture();
	RULES_Texture * texQualUp2 =		new RULES_Texture();
	RULES_Texture * texQualDown1 =		new RULES_Texture();
	RULES_Texture * texQualDown2 =		new RULES_Texture();
	RULES_Texture * glowQualUp1 =		new RULES_Texture();
	RULES_Texture * glowQualUp2 =		new RULES_Texture();
	RULES_Texture * glowQualDown1 =		new RULES_Texture();
	RULES_Texture * glowQualDown2 =		new RULES_Texture();
	RULES_Texture * filtrageQualUp1 =	new RULES_Texture();
	RULES_Texture * filtrageQualUp2 =	new RULES_Texture();
	RULES_Texture * filtrageQualDown1 =	new RULES_Texture();
	RULES_Texture * filtrageQualDown2 =	new RULES_Texture();

	retour1			->loadBMP("./ressources/textures/ihm/retour1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	retour2			->loadBMP("./ressources/textures/ihm/retour2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	loutreCheck1	->loadBMP("./ressources/textures/ihm/check.bmp"  ,true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	loutreCheck2	->loadBMP("./ressources/textures/ihm/check.bmp"  ,true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	texQualUp1		->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	texQualUp2		->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	texQualDown1	->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	texQualDown2	->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	glowQualUp1		->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	glowQualUp2		->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	glowQualDown1	->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	glowQualDown2	->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	filtrageQualUp1	->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	filtrageQualUp2	->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	filtrageQualDown1->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	filtrageQualDown2->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);

	retour			->setImageNormal(retour2);
	retour			->setImagePassed(retour1);
	loutreLowCheck	->setImageNormal(loutreCheck1);
	loutreLowCheck	->setImagePassed(loutreCheck2);
	texQualityUp	->setImageNormal(texQualUp1);
	texQualityUp	->setImagePassed(texQualUp2);
	texQualityDown	->setImageNormal(texQualDown1);
	texQualityDown	->setImagePassed(texQualDown2);
	glowQualityUp	->setImageNormal(glowQualUp1);
	glowQualityUp	->setImagePassed(glowQualUp2);
	glowQualityDown	->setImageNormal(glowQualDown1);
	glowQualityDown	->setImagePassed(glowQualDown2);
	filtrageQualityUp	->setImageNormal(filtrageQualUp1);
	filtrageQualityUp	->setImagePassed(filtrageQualUp2);
	filtrageQualityDown	->setImageNormal(filtrageQualDown1);
	filtrageQualityDown	->setImagePassed(filtrageQualDown2);

	retour			->setPosition(100,650);
	retour			->setHeight(32);
	retour			->setWidth(64);

	loutreLowCheck	->setPosition(100,250);
	loutreLowCheck	->setHeight(16);
	loutreLowCheck	->setWidth(16);

	texQualityUp	->setPosition(320,350);
	texQualityUp	->setHeight(16);
	texQualityUp	->setWidth(16);

	texQualityDown	->setPosition(100,350);
	texQualityDown	->setHeight(16);
	texQualityDown	->setWidth(16);

	glowQualityUp	->setPosition(320,550);
	glowQualityUp	->setHeight(16);
	glowQualityUp	->setWidth(16);

	glowQualityDown	->setPosition(100,550);
	glowQualityDown	->setHeight(16);
	glowQualityDown	->setWidth(16);

	filtrageQualityUp	->setPosition(320,450);
	filtrageQualityUp	->setHeight(16);
	filtrageQualityUp	->setWidth(16);

	filtrageQualityDown	->setPosition(100,450);
	filtrageQualityDown	->setHeight(16);
	filtrageQualityDown	->setWidth(16);
}

VideoMenu::~VideoMenu()
{
	if (image != NULL)
	{
		delete this->image ;
		image = NULL;
	}
	if (retour != NULL)
	{
		delete this->retour ;
		retour = NULL;
	}
	if (loutreLowCheck != NULL)
	{
		delete this->loutreLowCheck ;
		loutreLowCheck = NULL;
	}
	if (texQualityUp != NULL)
	{
		delete this->texQualityUp ;
		texQualityUp = NULL;
	}
	if (texQualityDown != NULL)
	{
		delete this->texQualityDown ;
		texQualityDown = NULL;
	}
	if (glowQualityUp != NULL)
	{
		delete this->glowQualityUp ;
		glowQualityUp = NULL;
	}
	if (glowQualityDown != NULL)
	{
		delete this->glowQualityDown ;
		glowQualityDown = NULL;
	}
	if (filtrageQualityUp != NULL)
	{
		delete this->filtrageQualityUp ;
		filtrageQualityUp = NULL;
	}
	if (filtrageQualityDown != NULL)
	{
		delete filtrageQualityDown ;
		filtrageQualityDown = NULL;
	}

}

void VideoMenu::draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	gluLookAt(0,100,100,0,0,0,0,1,0);
	// affiche un rectangle de test
	// on desactive le depth test
	glDisable(GL_DEPTH_TEST);
	// on passe en mode projection
	glMatrixMode(GL_PROJECTION);
		
				// on sauvegarde la matrice de projection
	glPushMatrix();
	
		// on nettoie la matrice de projection
		glLoadIdentity();
		
		// on passe en mode ortho de la taille de l'ecran
		glOrtho(0,1024,0,768,-1,1);	
		
		// on passe en mode modelview
		glMatrixMode(GL_MODELVIEW);
		
		// on sauvegarde la matrice de modelview
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, this->image->getId());
			glBegin(GL_QUADS);
				glTexCoord2f(0,0);
				glVertex3f(0,0,0);
				glTexCoord2f(1,0);
				glVertex3f(1024,0,0);
				glTexCoord2f(1,1);
				glVertex3f(1024,768,0);
				glTexCoord2f(0,1);
				glVertex3f(0,768,0);
			glEnd();

			glMatrixMode(GL_PROJECTION);
		
		// et on recupere la matrice de projection sauvegard precedement
		glPopMatrix();	
		
		// on selectionne la matrice de projection modelview
		glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	// on desactive le depth test
	glEnable(GL_DEPTH_TEST);

	//glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER,0);

	retour			->draw(mouseX,mouseY);
	loutreLowCheck	->draw(mouseX,mouseY);
	texQualityUp	->draw(mouseX,mouseY);
	texQualityDown	->draw(mouseX,mouseY);
	glowQualityUp	->draw(mouseX,mouseY);
	glowQualityDown	->draw(mouseX,mouseY);
	filtrageQualityUp	->draw(mouseX,mouseY);
	filtrageQualityDown	->draw(mouseX,mouseY);

	//glDisable(GL_ALPHA_TEST);

	Font * font = MainMenu::getInstance()->getFont();
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_SRC_ALPHA);
	font->glText2d(400*0.78,100*0.78,"Options video");
	font->glText2d(120*0.78,250*0.78,"Loutre basse qualite");
	font->glText2d(340*0.78,350*0.78,"Qualite des textures");
	font->glText2d(340*0.78,450*0.78,"Filtrage des textures");
	font->glText2d(340*0.78,550*0.78,"Qualite du glow");
	switch(texQuality)
	{
	case 0:
		font->glText2d(120*0.78,350*0.78,"Haute");
		break;
	case 1:
		font->glText2d(120*0.78,350*0.78,"Bonne");
		break;
	case 2:
		font->glText2d(120*0.78,350*0.78,"Moyenne");
		break;
	case 3:
		font->glText2d(120*0.78,350*0.78,"Faible");
		break;
	}
	switch(filtrageQuality)
	{
	case 0:
		font->glText2d(120*0.78,450*0.78,"Pas de filtrage");
		break;
	case 1:
		font->glText2d(120*0.78,450*0.78,"Lineaire");
		break;
	case 2:
		font->glText2d(120*0.78,450*0.78,"Bilineaire");
		break;
	case 3:
		font->glText2d(120*0.78,450*0.78,"Trilineaire");
		break;
	}
	switch(glowQuality)
	{
	case 0:
		font->glText2d(120*0.78,550*0.78,"Desactive");
		break;
	case 1:
		font->glText2d(120*0.78,550*0.78,"Moyenne");
		break;
	case 2:
		font->glText2d(120*0.78,550*0.78,"Maximum");
		break;
	}
	if (loutreLow)
	{
		font->glText2d(99*0.78,249*0.78,"X");
	}

	RULES_Vector pos;
	pos.setCoord(mouseX,768-mouseY,0);
	ParticleEngine::getInstance()->frame(&pos);
	Mouse::getInstance()->draw(&pos);

	glFlush();
	glutSwapBuffers();
	// on lui fait charger la partie

}


void VideoMenu::idle(void)
{
	// on charge le sound manager et on verifie le son
	SoundManager::getInstance()->checkSound();
	glutPostRedisplay();

}


void VideoMenu::mouseClicked(int boutton,int etat,int x,int y)
{
	if (etat == GLUT_DOWN)
	{
		SoundManager::getInstance()->playClic();
		if (retour->isIn(x,y))
		{
			settingHasChange = false;
			GLUT * main = OptionMenu::getInstance();
			*(this->currentGlut) = main; 
			main->setCurrentGlut(this->currentGlut);

			Game::getGame()->loadRessources(texQuality,filtrageQuality,loutreLow);
			Game::getGame()->setGlowLevel(glowQuality);
		}
		if (texQualityDown->isIn(x,y))
		{
			settingHasChange = true;
			texQuality ++;
			if (texQuality > 3)
			{
				texQuality = 3;
			}
		}
		if (texQualityUp->isIn(x,y))
		{
			settingHasChange = true;
			texQuality --;
			if (texQuality < 0)
			{
				texQuality = 0;
			}
		}
		if (glowQualityUp->isIn(x,y))
		{
			settingHasChange = true;
			glowQuality ++;
			if (glowQuality > 2)
			{
				glowQuality = 2;
			}
		}
		if (glowQualityDown->isIn(x,y))
		{
			settingHasChange = true;
			glowQuality --;
			if (glowQuality < 0)
			{
				glowQuality = 0;
			}
		}
		if (filtrageQualityUp->isIn(x,y))
		{
			settingHasChange = true;
			filtrageQuality ++;
			if (filtrageQuality > 3)
			{
				filtrageQuality = 3;
			}
		}
		if (filtrageQualityDown->isIn(x,y))
		{
			settingHasChange = true;
			filtrageQuality --;
			if (filtrageQuality < 0)
			{
				filtrageQuality = 0;
			}
		}
		if (loutreLowCheck->isIn(x,y))
		{
			settingHasChange = true;
			loutreLow = !loutreLow;
		}
	}
}

void VideoMenu::mouseMoved(int x,int y)
{
	mouseX = x;
	mouseY = y;
}

void VideoMenu::mouseMovedClicked(int x,int y)
{

}


void VideoMenu::keyPressed(unsigned char key,int x,int y)
{
}

void VideoMenu::keyReleased(unsigned char key,int x,int y)
{
	if (key == 27)
	{
		GLUT * main = OptionMenu::getInstance();
		*(this->currentGlut) = main; 
		main->setCurrentGlut(this->currentGlut);
	}

}


void VideoMenu::reshape(int largeur,int hauteur)
{
	glViewport(0,0,(GLsizei) largeur,(GLsizei) hauteur);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,largeur/hauteur,1,10000);
	glMatrixMode(GL_MODELVIEW);

}

